/*
	Pagevamp Component: %name%
*/
(function(componentId) {
	window.meanEngine.registerEditor(function(angularApp) {
		
		angularApp.directive(componentId+'editor', function($compile) {
			var component = function($scope, $element, $attrs) {
				
				// Get the component's editor ID
				var editorId 	= $attrs['pagevampComponentId'];
				var editorUuid 	= $attrs['pagevampComponentUuid'];
				
				// Get the component's data
				$scope.data = window.meanEngine.get('components').getSettingsFor(editorUuid);
				
				// variables
				$scope.saving	= false;
				
				// Save method
				$scope.save = function(closeEditor) {
					
					$scope.saving = true;
					
					window.meanEngine.get('components').setDataFor(editorUuid, $scope.data, function(response) {
						$scope.$apply(function() {
							$scope.saving = false;
							if (closeEditor) {
								$scope.cancel();
							}
						});
					});
				}
				
				// Cancel method
				$scope.cancel = function() {
					meanEngine.get('event').inform('pagevamp.editor.hide', {
						editorId:		editorId
					});
				}
				$compile($element.contents())($scope);
			}
			return {
				link: 			component,
				replace:		false,
				scope:			{},
				templateUrl:	window.meanEngine.get('components').getUrlFor('editor/editor.html', componentId)
			};
		});
	});
})('%id%');